using System;
using System.IO;
using System.Text;


namespace EncodingConvertor
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class EncodingConvertor
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			if(args.Length < 4)
			{
				Console.WriteLine("EncodingConvertor v0.002");
                Console.WriteLine("Underdog Projects, http://www.underdogprojects.com/encodingconvertor/");
				Console.WriteLine("Usage: [input file] [input encoding] [output file] [output encoding]");
                Console.WriteLine("");
                Console.WriteLine("Encoding types are:");
                foreach(EncodingInfo enc in Encoding.GetEncodings())
                    Console.WriteLine(enc.Name);
                Console.WriteLine("");
                Console.WriteLine("Sample Usage:");
                Console.WriteLine("EncodingConvertor.exe inputfile.txt utf-8 outputfile.txt Windows-1255");
                return;
			}

			try
			{
				FileStream from = new FileStream(args[0], FileMode.Open, FileAccess.Read);
				Encoding fromEnc = Encoding.GetEncoding(args[1]);
			
				FileStream to = new FileStream(args[2], FileMode.Create, FileAccess.Write);
				Encoding toEnc = Encoding.GetEncoding(args[3]);

				byte[]        buf = new byte[8192];
				int    count      = 0;
				do
				{
			
					// fill the buffer with data
					count = from.Read(buf, 0, buf.Length);

					// make sure we read some data
					if (count != 0)
					{
						// translate from encoding to 1255 encoding
						byte[] newbuf = Encoding.Convert(fromEnc, toEnc, buf, 0, count);
					
						// continue building the string
						to.Write(newbuf, 0, newbuf.Length);
					}
				}
				while (count > 0); // any more data to read?
		
				to.Close();
				from.Close();
			}
			catch(Exception ex)
			{
				Console.WriteLine("Error EncodingConvertor: " + ex.ToString());
			}
		}

	}
}
